package com.krishagni.os.configuration;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.ws.rs.core.MediaType;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
public class Configurations {

	public static void main(String args[]) {

		InputStream input = null;

		try {

			if(args == null || args.length != 4){
				throw new RuntimeException("Missing parameters.");
			}
			String filePath = args[0];
			File file = new File(filePath);
			if(!file.exists()){
				throw new RuntimeException("Specified file doesn't exist");
			}
			
			String url = args[1] + "/rest/ng/config-settings";
			String user = args[2];
			String password = args[3];
			
			input = new FileInputStream(file);
//			String json = prop.getProperty("json");
//			String requestType = prop.getProperty("requestType");
			BufferedReader reader = null;
			try {
				ClientConfig config = new DefaultClientConfig();

				Client client = null;
				client = Client.create(config);

				client.addFilter(new com.sun.jersey.api.client.filter.HTTPBasicAuthFilter(
						user, password));
				reader = new BufferedReader(new InputStreamReader(input));
				String line = null;
				
				while ((line = reader.readLine()) != null) {
					if (line.startsWith("#")) {
						continue;
					}
					
					String[] fields = line.split(",(?=([^\"]*\"[^\"]*\")*[^\"]*$)");
					if (fields.length != 3) {
						System.out.println("Invalid input line: " + line + ". Ignoring");
						continue;
					}
					
//					String subUrl = fields[0].trim().replaceAll("\"", "");
					String module = fields[0].trim().replaceAll("\"", "");
					String name = fields[1].trim().replaceAll("\"", "");
					String value = fields[2].trim().replaceAll("\"", "");
//					String 	method = fields[3].trim().replaceAll("\"", "");
					String method = "PUT";
					
					Configurations configurations = new Configurations();
					Json json = configurations.new Json(module, name, value);
					
					
//					if (StringUtils.isEmpty(subUrl)) {
//						System.out.println("Invalid input line: " + line + ". Sub URL is empty. Ignoring");
//						continue;
//					}
					
					if (StringUtils.isEmpty(method)) {
						System.out.println("Invalid input line: " + line + ". Method is empty. Ignoring");					
						continue;
					}
					setProperty(url, client, json, method);
				}
			} catch (Exception e) {
				System.out.println("Error:");
				System.err.println(e.getMessage());
			} finally {
				IOUtils.closeQuietly(reader);
			}
			
		} catch (Exception e) {
			System.out.println(e);
		}
	}

	private static WebResource setProperty(String url, Client client, Json json, String method) {
		ClientResponse response;
		WebResource service = client.resource(url);
		try {
			String gson = "{\"module\":\""+json.module+"\",\"name\":\""+json.name+"\", \"value\":\""+json.value+"\"}";
			if("POST".equalsIgnoreCase(method)){
				response = service.type(MediaType.APPLICATION_JSON).post(ClientResponse.class, gson);
			}else{
				response = service.type(MediaType.APPLICATION_JSON).put(ClientResponse.class, gson);
			}
			System.out.println(response.toString());
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		return service;
	}
	
	class Json{
		public Json(String module2, String name2, String value2) {
			module = module2;
			name = name2;
			value = value2;
		}
		String module;
		String name;
		String value;
	}
}
