package com.krishagni.os.configuration;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Properties;

import javax.ws.rs.core.MediaType;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
public class OldConfigurations {

	public static void main(String args[]) {

		Properties prop = new Properties();
		InputStream input = null;

		try {

			if(args == null || args.length != 1){
				throw new RuntimeException("File path not specified.");
			}
			String filePath = args[0];
			File file = new File(filePath);
			if(!file.exists()){
				throw new RuntimeException("Specified file doesn't exist");
			}
			
			input = new FileInputStream(file);
			prop.load(input);
			String url = prop.getProperty("url");
			String json = prop.getProperty("json");
			String user = prop.getProperty("user");
			String password = prop.getProperty("password");
			String requestType = prop.getProperty("requestType");

			ClientResponse response = null;
			ClientConfig config = new DefaultClientConfig();

			Client client = null;
			client = Client.create(config);

			client.addFilter(new com.sun.jersey.api.client.filter.HTTPBasicAuthFilter(
					user, password));
			WebResource service = client.resource(url);
			try {
				
				if("POST".equalsIgnoreCase(requestType)){
					response = service.type(MediaType.APPLICATION_JSON).post(ClientResponse.class, json);
				}else{
					response = service.type(MediaType.APPLICATION_JSON).put(ClientResponse.class, json);
				}
				System.out.println(response.toString());
			} catch (Exception e) {
				System.err.println(e.getMessage());
			}
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
